function camera = generate_camera_data(camType)
% cameraData = generate_camera_data(camType)
%
% camType: 'PMD_16x64', 'PMD_120x160', 'SR_176x144', 'SR_176x144calib'

camera = struct('name', [], 'height', 0, 'width', 0, 'focalLength', 0, 'principalPoint', [], 'pixelWidth', 0, 'pixelHeight', 0);

%all values are given in mm
if(strcmp(camType, 'PMD_16x64'))
    camera.name = 'PMD_16x64';
    camera.height = 16;
    camera.width = 64;
    camera.focalLength = 16;
    camera.principalPoint = [31.5 7.5];
    camera.pixelWidth = 0.1553;
    camera.pixelHeight = 0.2108;
elseif(strcmp(camType, 'PMD_120x160'))
    camera.name = 'PMD_120x160';
    camera.height = 120;
    camera.width = 160;
    camera.focalLength = 12;
    camera.principalPoint = [79.5 59.5];
    camera.pixelWidth = 0.04;
    camera.pixelHeight = 0.04;
elseif(strcmp(camType, 'SR_176x144'))
    camera.name = 'SR_176x144';
    camera.height = 144;
    camera.width = 176;
    camera.focalLength = 8;
    camera.principalPoint = [92 60];
    %camera.principalPoint = [88 72]; %take data from calibration
    camera.pixelWidth = 0.04;
    camera.pixelHeight = 0.04;
elseif(strcmp(camType, 'SR_176x144calib'))
    camera.name = 'SR_176x144';
    camera.height = 144;
    camera.width = 176;
    camera.focalLength = 8;
    camera.principalPoint = [86 70];
    camera.pixelWidth = 0.04;
    camera.pixelHeight = 0.04;
elseif(strcmp(camType, 'SR4_176x144'))
    camera.name = 'SR4_176x144';
    camera.height = 144;
    camera.width = 176;
    camera.focalLength = 10;
    camera.principalPoint = [88 72];
    camera.pixelWidth = 0.04;
    camera.pixelHeight = 0.04;
else
    display('Unknown camera type.');
end