function frame = srdat2frame(srMatrix, camType)
% frame = srdat2frame(srMatrix, camType)

frame = struct('distances', [], 'intensities', [], 'amplitudes', [], 'points3D', [], 'points3D_org', [], 'usage', []);

z = 1000*srMatrix(1:camType.height,:);
%z = z(:,end:-1:1);
z = reshape(z',1,[]);
x = 1000*srMatrix((camType.height+1):(2*camType.height),:);
%x = x(:,end:-1:1);
x = reshape(x',1,[]);
y = 1000*srMatrix((2*camType.height+1):(3*camType.height),:);
%y = y(:,end:-1:1);
y = reshape(y',1,[]);
amp = srMatrix((3*camType.height+1):(4*camType.height),:);
amp = reshape(amp',1,[]);

frame.amplitudes = amp;
% The Swissranger delivers the data in a right handed coordinate system
% with the first pixel being in the top-left corner. (-> positive x-values
% to the left)
% I prefer a left handed system with positive x-values to the right,
% therefore the sign of the x-values have to be switched.
% Warning: As MatLab uses a right-handed system the data has to be mirrored
% again in plot_3Dpoints for displaying
frame.points3D = [-x;y;z; ones(1,camType.width*camType.height)];
frame.points3D_org = frame.points3D;

% if(size(srMatrix,1) > 4*camType.height)
%     u = srMatrix((4*camType.height+1):(5*camType.height),:);
%     u = reshape(u',1,[]);
%     frame.usage = find(u == 1);
% else 
%     frame.usage = 1:1:(camType.width*camType.height);
% end
% 
% if(size(srMatrix,1) > 5*camType.height)
%     nX = srMatrix((5*camType.height+1):(6*camType.height),:);
%     nX = reshape(nX',1,[]);
%     nY = srMatrix((6*camType.height+1):(7*camType.height),:);
%     nY = reshape(nY',1,[]);
%     nZ = srMatrix((7*camType.height+1):(8*camType.height),:);
%     nZ = reshape(nZ',1,[]);
%     frame.normals = [nX; nY; nZ];
%     frame.planar = frame.usage;
%     frame.notplanar = find(u == 0);
%     
%     i = 1 : camType.width*camType.height;
%     pos = reshape(i, camType.width, [])';
%     i = mat2cell(i, 1, ones(1, camType.width*camType.height));
%     indx = cellfun(@(x)(getNgbIndx(x, camType.width, camType.height, 3, true, pos)), i, 'UniformOutput', false);
%     frame = setfield(frame, 'indx8', indx);
%     
% end

frame = projection(frame, camType);
