function [cl, clIndx] = cluster_through_gmd_stable(pnts, display)

if(nargin < 2)
    display = false;
end

gmdata = pnts';

bench = realmax;
benchvec = [];
conv = true;

c = 2;
while(1)

    log = [];
    
    while(1)
        
        try
            obj = gmdistribution.fit(gmdata, c);
        catch
            continue;
        end   
        
        log = [log round(obj.NlogL)];
        
        if(~obj.Converged)
            conv = false;
            break;
        end
        
        if(min(log)/max(log) < 0.5)
            break;
        end
        
        if(any(log(1:end-1) == log(end)))
            break;
        end
        
    end
    
    if(~conv)
        break;
    end
    
    if(log(end) < bench)    
        idx = cluster(obj, gmdata);
        [cl, clIndx] = pnts2clusters(pnts, idx);
        bench = log(end);
    else
        break;
    end
    
    benchvec = [benchvec bench];
    if(length(benchvec) > 1)
        benchvecnorm = benchvec/benchvec(1);
        g = abs(gradient(benchvecnorm));
        if(~isempty(find(g < 10^-3)))
            break;
        end
    end
    
    c = c+1;
    
end

if(display)
    show_clusters(cl);
end
