function [foregr, backgr] = foreground_background_separation(scene)
% [foregr, backgr] = foreground_background_separation(scene)
%
% find the two z-ranges where most of the points are lying in
% assumption: in the background a lot of points will have a similar z-value as
% well as the points in the foreground -> find threshold (somewhere between the
% two significant z-values) which determines if a point belongs to the
% foreground or to the background

mi = min(scene(3,:));
ma = max(scene(3,:));

bins = round((ma - mi) / 200);

[n, z] = hist(scene(3,:), bins);
[nSort, iSort] = sort(n);

iMax1 = iSort(end);
iMax2 = iSort(end-1);

tPos = round((iMax1 * n(iMax1) + iMax2 *n(iMax2)) / (n(iMax1) + n(iMax2)));

t = z(tPos);

foregr = scene(1:3, find(scene(3,:) < t));
backgr = scene(1:3, find(scene(3,:) >= t));

fig = plot_3Dpoints(foregr, 'b');
fig = plot_3Dpoints(backgr, 'r', fig);


