function [normals, d, deviation] = local_plane_patches(pnts, width, height, usage, neighborhood, woCenter)
%% [normals, deviation] = local_plane_patches(pnts, width, height, usage, neighborhood, woCenter)
% 
% compute for each point its normal using a certain neighborhood of points

%% initialize same values:

if(nargin < 6)
    woCenter = false;
end

deviation = zeros(1, height*width);
d = zeros(1, height*width);

pos = 1:1:length(pnts);
pos = reshape(pos, width, [])';

x = zeros(1, height*width);
y = zeros(1, height*width);
z = zeros(1, height*width);


%% normal computation:
% Compute for each point its normal based on points of any surrounding
% neighborhood 

i = 1;
while(i <= length(usage))
    
    currIndx = usage(i);
    ngbIndx = getNgbIndx(currIndx, width, height, neighborhood, woCenter, pos);
    ngbIndx = ngbIndx(ismember(ngbIndx, usage));
    
    l = length(ngbIndx);
    ngbPnts = pnts(1:3, ngbIndx);
    meanPnt = sum(ngbPnts, 2) / l;

    %ngbPnts = [ngbPnts(1,:) - meanPnt(1); ngbPnts(2,:) - meanPnt(2); ...
    %    ngbPnts(3,:) - meanPnt(3)];

    %cov = ngbPnts * ngbPnts';

    %[vec, val] = eig(cov);
    %[mi, in] = min([val(1,1) val(2,2) val(3,3)]);

    %x(currIndx) = vec(1, in);
    %y(currIndx) = vec(2, in);
    %z(currIndx) = vec(3, in);
    %deviation(currIndx) = mi; 
    %d(currIndx) = vec(:, in)' * meanPnt;
    
    
    % slower in computation -> question: better results? no?!
    [coeff, score, roots] = princomp(ngbPnts');
    vec = coeff(:,3);
     
    x(currIndx) = vec(1);
    y(currIndx) = vec(2);
    z(currIndx) = vec(3);
     
    deviation(currIndx) = mean(abs(score(:,3)));
    d(currIndx) = vec' * meanPnt;
    
    i = i+1;
    
end

normals = [x;y;z];
