function [patchesMerged, rest, restIndx] = patch_merging(patches, method)
%% planesMerged = patch_merging(patches, method)
%
% possible methods:
%  - 'mean': uses the mean of the patches
%  - 'median': uses the median of the patches
%  - 'ngbPatches': uses the nearest neighbor patches
%  - 'fastNgbPatches': finds quick nearest neighbor patches 

nOld = 0;
n = length(patches);
rest = [];
restIndx = [];

patchesMerged = patches;

while(nOld ~= n)
    
    [patchesMerged, r, rIndx] = merge_planes(patchesMerged, method);
    
    rest = [rest r];
    restIndx = [restIndx rIndx];
    
    nOld = n;
    n = length(patchesMerged);
    
end
    