function [planes, rest, restIndx] = plane_segmentation(points, indx, numPlanes, display)
% [planes, rest] = plane_segmentation(pnts, indx, numPlanes, display)
% 
% find 'numPlanes' planes in the point cloud 'points'

if(nargin < 4)
    display = false;
end

if(nargin < 3)
    numPlanes = [];
end

if(nargin < 2)
    indx = 1:size(points,2);
end

planes = [];
plane = struct('pnts', [], 'n', [], 'd', 0);
pnts = points;

while(size(pnts, 2) >= 3)
    
    [posEnd, nEnd, dEnd] = main_plane_extraction(pnts);
    
    if(isempty(posEnd)) break; end
    
    plane.pnts = pnts(1:3, posEnd);
    plane.n = nEnd;
    plane.d = dEnd;
    plane.indx = indx(posEnd);
    planes = [planes plane];
    
    pnts(:,posEnd) = [];
    indx(posEnd) = [];
    
end

% rest = points(1:3, posRest);
rest = pnts;
restIndx = indx;

if(~isempty(numPlanes))
    planesAll = planes;
    planes = planesAll(1:numPlanes);
    % rest = [rest cat(2, planesAll{numPlanes+1:end})];
    rest = [rest [planesAll(numPlanes+1:end).pnts]];
end

if(display)

    fig = show_clusters({planes.pnts}, 0);
    fig = plot_3Dpoints(rest, 'k', fig);
    
end
