function [normals, d deviation] = voxel_plane_patches(voxel, vList, nbrVoxel)
%% [normal, d deviation] = voxel_plane_patches(pnts, ngh)

normals = [];
deviation = [];
d = [];

i = 1;
while(i <= length(vList))
    
    curr = vList(i);
    ngb = find_voxel_neigbors(curr, nbrVoxel);
    
    in = ismember(vList, ngb);
    in = find(in == 1);
    
    l = length(in);
    ngbPnts = [voxel{in}];
    meanPnt = sum(ngbPnts, 2) / l;

    ngbPnts = [ngbPnts(1,:) - meanPnt(1); ngbPnts(2,:) - meanPnt(2); ...
        ngbPnts(3,:) - meanPnt(3)];

    cov = ngbPnts * ngbPnts';

    [vec, val] = eig(cov);
    [mi, in] = min([val(1,1) val(2,2) val(3,3)]);

    x = vec(1, in);
    y = vec(2, in);
    z = vec(3, in);
    n = [x;y;z];
    
    normals = [normals; {repmat(n, 1, size(voxel{i}, 2))}];
    deviation = mi; 
    d(currIndx) = vec(:, in)' * meanPnt;
