function distances = amplitude_adaptive_median(dis, amp, camType)

distances = dis;

dis1 = medfilt2(dis, [7 7]);
dis2 = medfilt2(dis, [5 5]);
dis3 = medfilt2(dis, [3 3]);

t1 = 0;
t2 = 0;

minAmp = min(min(amp));
maxAmp = max(max(amp));
range = maxAmp - minAmp;

t1 = minAmp + 1/3*range;
t2 = minAmp + 2/3*range;

u1 = find(dis < t1);
u2 = find(dis >= t1 & dis < t2);
u3 = find(dis >= t2);

distances(u1) = dis1(u1);
distances(u2) = dis2(u2);
distances(u3) = dis3(u3);
