function frame = compute_normals(fr, camType)
%% frame = compute_normals(fr, camType)

frame = fr;
w = camType.width;
h = camType.height;

[normals, d, dev] = local_plane_patches(frame.points3D, ...
            w, h, frame.usage, 5);
        
%% classify if points are planar or not:
%thres_dev = 0.67 * mean(deviation);
%thres_dev = 1 * mean(deviation);
%planarIndx = find(deviation <= 2000); %Swissranger
%notPlanarIndx = find(deviation > 2000); %Swissranger
%planarIndx = find(deviation <= 3000); %DC_Tracking
%notPlanarIndx = find(deviation > 3000); %DC_Tracking

thres_dev = 1 * mean(dev) + std(dev);
planarIndx = find(dev <= thres_dev);
notPlanarIndx = find(dev > thres_dev);
planarIndx = planarIndx(ismember(planarIndx, frame.usage));
notPlanarIndx = notPlanarIndx(ismember(notPlanarIndx, frame.usage));

%% store
frame.normals = normals;
frame.d = d;
frame.dev = dev;
frame.planar = planarIndx;
frame.notplanar = notPlanarIndx;