function frame = open_close_usage(fr, camType, method)
% frame = open_close_usage(fr, camType, method)

frame = fr;

usage = fr.usage;
width = camType.width;
height = camType.height;

map = zeros(1, width*height);
map(usage) = 1;
map = reshape(map, width, [])';

se = strel('square', 3);
%se = strel('disk', 1);
if(strcmp(method, 'open-close'))
    map = imopen(imclose(map, se),se);
elseif(strcmp(method, 'open'))
    map = imopen(map, se);
elseif(strcmp(method, 'close-open'))
    map = imclose(imopen(map, se),se);
elseif(strcmp(method, 'close'))
    map = imclose(map, se);
else
    disp('Error: Unknown morphological method!');
end
        
map = reshape(map', 1, []);

use = find(map == 1);

frame.usage = use;