function frame = thresholding(fr, camType)
%% frame = thresholding(fr, camType)

frame = fr;

%% thresholding on amplitudes: 
meanAmp = 1/length(frame.amplitudes) * sum(frame.amplitudes);
threshold = 1/3 * meanAmp;

frame.usage = find(frame.amplitudes>=threshold);

%% add some additional data with bad amplitudes but stable neighborhood
% (slow operation)
% dis = reshape(frame.distances, camType.width, [])';
% 
% j = 1:camType.width;
% j = repmat(j, 1, camType.height);
% j = num2cell(j);
% 
% i = 1:camType.height;
% i = i';
% i = repmat(i, 1, camType.width);
% i = reshape(i', 1, []);
% i = num2cell(i);
% 
% currD = num2cell(frame.distances);
% 
% currN = cellfun(@(x,y,d) (reshape(abs(get8region(dis,x,y) - d)', 1, [])), ...
%     i, j, currD, 'UniformOutput', false);
% 
% distribution = cellfun(@(x)(sqrt(sum((x-mean(x)).^2)/(length(x)-1))), currN, 'UniformOutput', false);
% distribution = [distribution{1:end}];
% 
% stdD = std(distribution);
% 
% add = find(frame.amplitudes < threshold & distribution < stdD/3);
% 
% dis7 = medfilt2(dis, [9 9]);
% dis7 = reshape(dis7', 1, []);
% frame.distances(add) = dis7(add);
% 
% frame.usage = [frame.usage add];
