function bool = iscolinear(p1, p2, p3)
% function bool = test_colinearity(p1, p2, p3)

if(nargin == 1 && size(p1,2) == 3)
    p2 = p1(:,2);
    p3 = p1(:,3);
    p1 = p1(:,1);
end

a = sqrt(sum((p3-p2).^2));
b = sqrt(sum((p1-p3).^2));
c = sqrt(sum((p2-p1).^2));

if( a == 0 || b == 0 || c == 0)
    bool = true;
    return;
end

% a^2 = b^2 + c^2 - 2bc cos(alpha)
% b^2 = c^2 + a^2 - 2ac cos(beta)
% c^2 = a^2 + b^2 - 2ab cos(gamma)
alpha = acos((a^2 - b^2 - c^2) / (-2*b*c));
beta = acos((b^2 - c^2 - a^2) / (-2*c*a));
gamma = acos((c^2 - a^2 - b^2) / (-2*a*b));

theta1 = pi/32;
theta2 = pi - theta1;

if( alpha<theta1 || alpha>theta2 )
    bool = true;
elseif( beta<theta1 || beta>theta2 )
    bool = true;
elseif( gamma<theta1 || gamma>theta2 )
    bool = true;
else
    bool = false;
end