function[Pnts_new, Rot] = position_point_cloud(Pnts)
% Pnts_new = position_point_cloud(Pnts)
% Pnts = 3 x n matrix = 3D point cloud
% Pnts_new = 3 x n matrix, new relocated point cloud
%
% Positions given point cloud to be parallel to the image plane.

% finding plane in point_cloud
[posEnd, normal, dEnd] = main_plane_extraction(Pnts(1:3,:));
%[coeff, score, roots] = princomp(Pnts(1:3,:)');
%normal = coeff(:,3);

% determine center
center = sum(Pnts,2)./size(Pnts,2);

%% move points with center to origin
%Tc = eye(4);
%Tc(1:3,4) = -1*center(1:3);
%Pnts_new = Tc * Pnts_new;
%Pnts_new = Pnts-repmat([center(1:3); 0], 1, size(Pnts,2));
T1 = [1 0 0 -center(1); 0 1 0 -center(2); 0 0 1 -center(3); 0 0 0 1];
T2 = [1 0 0 0; 0 1 0 0; 0 0 1 center(3); 0 0 0 1];

%% calculate angles for rotation
angle1 = atan(normal(1)/normal(2));
Rot1 = [cos(angle1) -sin(angle1) 0 0; sin(angle1) cos(angle1) 0 0; 0 0 1 0; 0 0 0 1];
normal_new = Rot1*[normal;1];
angle2 = atan(normal_new(2)/normal(3));
Rot2 = [1 0 0 0; 0 cos(angle2) -sin(angle2) 0; 0 sin(angle2) cos(angle2) 0; 0 0 0 1];

%% transformation matrix
Rot = T2*Rot2*Rot1*T1;


% Rot = [cos(angle1) -sin(angle1) 0 -center(1)*cos(angle1)+center(2)*sin(angle1); ...
%     cos(angle2)*sin(angle1) cos(angle2)*cos(angle1) -sin(angle2) -center(1)*cos(angle2)*sin(angle1)-center(2)*cos(angle2)*cos(angle1)+center(3)*sin(angle2); ...
%     sin(angle2)*sin(angle1) sin(angle2)*cos(angle1) cos(angle2) -center(1)*sin(angle2)*sin(angle1)-center(2)*sin(angle2)*cos(angle1)- center(3)*cos(angle2)+center(3); ...
%     0 0 0 1];
% rotate points in origin


Pnts_new = Rot * Pnts;

% % move points to have center on z-axis
%Pnts_new = Pnts_new + repmat([0;0;center(3);0], 1, size(Pnts_new,2));