function visualize_sequence(seq)
%% visualize_sequence(seq)

disp('Click the mouse button to show the next frame of the sequence.');
disp('Click a keyboard button to terminate the programm.');

n = length(seq.frames);
i = 1;
fig = figure;

while(i <= n)
    
    imAmp = sqrt(seq.frames(i).amplitudes);
    imAmp = imAmp - min(imAmp);
    imAmp = imAmp ./ max(imAmp);
    imAmp = reshape(imAmp, 176, [])';
    imDis = seq.frames(i).distances;
    imDis = reshape(imDis, 176, [])';
    
    figure(fig);
    set(fig, 'Name', ['Frame ' num2str(i)]);
    subplot(1,2,1), subimage(imAmp), axis off;
        
    subplot(1,2,2), imshow(imDis, []), colormap(jet);
        
    %fig3D = plot_3Dpoints(seq.frames(i).points3D_org(1:3, seq.frames(i).usage), 'jet');
    
    w=waitforbuttonpress;
    
    if(w) close all; return; end
    
    %close(fig3D);
    
    i = i+1;
    
end

close all;

